#include <iostream>

#include <Event.h>

void ProcessMessage(const std::string& message)
{
    std::cout << "Received: " << message << std::endl;
}

int main() {

    Event<std::string> OnMessage;

    bool run = true;

    auto handler = OnMessage += [&] (const std::string& message)
    {
        std::cout << "GOTS A MESSAGE: " << message << std::endl;
    };
    auto handler2 = OnMessage += ProcessMessage;

    while (run)
    {
        std::string input;
        std::cin >> input;
        OnMessage.Invoke(input);
    }

    return 0;
}

#ifdef _WIN32
extern "C" {
    int wmain(int argc, wchar_t* argv[]) {
        return main();
    }
}
#endif

